import 'dart:io';

import 'package:flutter/services.dart';

enum AdmostTrackingAuthorizationStatus {
  notDetermined,
  restricted,
  denied,
  authorized,
}

class AdmostATTrackingManager {
  static const MethodChannel _channel = const MethodChannel('admost_flutter');

  static Future<AdmostTrackingAuthorizationStatus>
      getTrackingAuthorizationStatus() async {
    if (Platform.isIOS) {
      final int status =
          (await _channel.invokeMethod<int>('getTrackingAuthorizationStatus'));
      return AdmostTrackingAuthorizationStatus.values[status];
    }
    return AdmostTrackingAuthorizationStatus.authorized;
  }

  static Future<AdmostTrackingAuthorizationStatus>
      requestTrackingAuthorization() async {
    if (Platform.isIOS) {
      final int status =
          (await _channel.invokeMethod<int>('requestTrackingAuthorization'));
      return AdmostTrackingAuthorizationStatus.values[status];
    }
    return AdmostTrackingAuthorizationStatus.authorized;
  }
}
